from cpl_discord.service import DiscordBotServiceABC
from cpl_query.extension import List

from bot_api.model.discord.server_dto import ServerDTO
from bot_api.transformer.server_transformer import ServerTransformer
from bot_data.abc.server_repository_abc import ServerRepositoryABC


class DiscordService:

    def __init__(
            self,
            bot: DiscordBotServiceABC,
            servers: ServerRepositoryABC,
    ):
        self._bot = bot
        self._servers = servers

    def get_all_servers(self) -> List[ServerDTO]:
        servers = self._servers.get_servers().select()
        return servers.select(
            lambda x: ServerTransformer.to_dto(x, self._bot.get_guild(x.discord_server_id).name, self._bot.get_guild(x.discord_server_id).member_count)
        )
